// seite geladen
$( document ).ready(function() {
	initGesamtpreis();
});

// für die varkombis
$( document ).ready(function() {
	var observer = new MutationObserver(function(mutations) {
			mutations.forEach(function(mutation) {
			//console.log('Mutation type: ' + mutation.type);
			if ( mutation.type == 'childList' ) {
				if (mutation.addedNodes.length >= 1) {
					//console.log(mutation.addedNodes[0]);
					if (mutation.addedNodes[0].id == 'result-wrapper') {
						initGesamtpreis();
						//console.log('Added ' + mutation.addedNodes[0].tagName + ' tag.');
			        	//console.log(mutation.addedNodes[0]);
			        	//console.log(mutation.addedNodes[0].id);
			        }
				} else if (mutation.removedNodes.length >= 1) {
					//console.log('Removed ' + mutation.removedNodes[0].tagName + ' tag.');
			        //console.log(mutation.removedNodes[0]);
				}
			} else if (mutation.type == 'attributes') {
				//console.log('Modified ' + mutation.attributeName + ' attribute.')
			}
		});   
	});
		  
	var observerConfig = {
		attributes: false,
		childList: true,
		characterData: false
	};
		  
	// Listen to all changes to body and child nodes
	var targetNode = $('#content')[0];
	observer.observe(targetNode, observerConfig);
});

// breite des dom elements ermitteln, wenn parent hidden
$.fn.getRealDimensions = function (outer) {
    var $this = $(this);
    if ($this.length == 0) {
        return false;
    }
    var $clone = $this.clone()
        .show()
        .css('visibility','hidden')
        .insertAfter($this);        
    var result = {
        width:      (outer) ? $clone.outerWidth() : $clone.innerWidth(), 
        height:     (outer) ? $clone.outerHeight() : $clone.innerHeight(), 
        offsetTop:  $clone.offset().top, 
        offsetLeft: $clone.offset().left
    };
    $clone.remove();
    return result;
}

// input feld geändert
$(document).on('change keyup paste', '#add-to-cart #quantity', function(el) {
	var mindestabnahme = parseInt($('#add-to-cart #quantity').data('min')),
		intervall = parseInt($('#add-to-cart #quantity').data('int')),
		livecalc = parseInt($('#add-to-cart #quantity-grp').data('livecalc')),
		error = false;
	console.log('Menge manuell geaendert: ' + $(el.target).val() + '; Mindestabnahme: ' + mindestabnahme);
	if (!isNaN(mindestabnahme) || !isNaN(intervall)) {
		var delay = 650;
		setTimeout(function() {
			console.log('mindestabnahme: ' + mindestabnahme);
			if (!isNaN(mindestabnahme)) {
				if ($(el.target).val() < mindestabnahme) {
					$(el.target).val(mindestabnahme);
					errorMindestabnahme();
					error = true;
				}
			}

			console.log('intervall: ' + intervall);
			if (!isNaN(intervall)) {
				var rest = $(el.target).val() % intervall;
				console.log('Rest: ' + rest);
				if (rest > 0) {
					$(el.target).val($(el.target).val() - rest);
					errorMindestabnahme();
					error = true;
				}
			}
		}, delay);
	} 

	if (livecalc == 1 && error === false) {
		calcGesamtpreis();
	}
});

// error Mindestabnahme
function errorMindestabnahme() {
	$(document).find('.purchase-info').addClass('alert-danger').removeClass('alert-info');
	var delay = 1000;
	setTimeout(function() {
		$(document).find('.purchase-info').addClass('alert-info').removeClass('alert-danger');
	}, delay);
}

// variation eingegeben
$(document).on('change', '.variation input', function() {
	var delay = 500;
	setTimeout(function() {
		calcGesamtpreis();
	}, delay);
});

// varianten aus select
$(document).on('change', '.variations select', function() {
	var delay = 500;
	setTimeout(function() {
		calcGesamtpreis();
	}, delay);
});

// gesamtpreis ermitteln
function calcGesamtpreis() {
	var livecalc = parseInt($('#add-to-cart #quantity-grp').data('livecalc'));

	if (livecalc === 1) {
		var price = $(document).find('#buy_form .product-offer .price_wrapper .price').text().trim(),
			qty = parseFloat($(document).find('input#quantity').val()),
			tax = parseInt($('#quantity').data('tax')),
			taxFaktor = 1 + (tax / 100),
			istNetto = parseInt($('#quantity').data('ist-netto')),
			trueNetto = parseInt($('#quantity').data('true-netto')),
			trueNettoWert = parseFloat($('#quantity').data('true-netto-wert')),
			mindestabnahme = parseInt($('#quantity').data('min')),
			bulkPrice_arr = $(document).find('.bulk-price > table > tbody > tr'),
			tmpPrice = null,
			priceCalc= null,
			bulkPrice = null,
			bulkPriceTmp = null,
			price_arr = null,
			priceString = '',
			gesamtpreis = null,
			gesamtpreisString = null
			;

		//console.log(price);
		if (typeof istNetto != 'undefined' && istNetto == 1) {
			taxFaktor = 1;
		}

		if (typeof trueNettoWert != 'undefined' && !isNaN(trueNettoWert)) {
			console.log('trueNettoWert: ' + trueNettoWert);
			priceCalc = trueNettoWert;
		}
		
		if (typeof bulkPrice_arr != 'undefined') {
			bulkPrice_arr.each(function(index) {
				if (!$(this).hasClass('buyedMost')) {
						bulk_qty = parseFloat($(this).find('td:first-child').html());
					tmpPrice = $(this).find('.bulk-price').html();
					if (qty >= bulk_qty) {
						price = tmpPrice;
						$('.bulk-price table > tbody tr').removeClass('set');
						$(this).addClass('set');
					}
					//console.log(index + ' - ' + qty + ' - ' + bulk_qty + ' - ' + price);	
				}	
			});
		}
		price_arr = price.split(" ");
		price = price_arr[0].replace('.','').replace(',','.');
		tmpPrice = parseFloat(price);
		if (typeof istNetto != 'undefined' && trueNetto == 1) {
			if (priceCalc == null) {
				priceCalc = Math.round((tmpPrice / taxFaktor) * 100,4) / 100;
			}
			console.log('Netto: ' + priceCalc);
			gesamtpreis = priceCalc * qty;
			console.log('Gesamtpreis Netto: ' + gesamtpreis);
			gesamtpreis = gesamtpreis * taxFaktor;	
			gesamtpreis = Math.round(gesamtpreis * 100,4) / 100;
		} else {
			priceCalc = tmpPrice;
			gesamtpreis = priceCalc * qty;
			gesamtpreis = Math.round(gesamtpreis * 100,4) / 100;
		}
		
		gesamtpreis = gesamtpreis.toLocaleString(undefined, { minimumFractionDigits: 2, maximumFractionDigits: 2 });
		priceString = price.toLocaleString(undefined, { minimumFractionDigits: 2, maximumFractionDigits: 2 }) + " " + price_arr[1];
		gesamtpreisString = gesamtpreis + " " + price_arr[1];
		$(document).find('#preisberechnung .preis').html(priceString);
		$(document).find('#preisberechnung .gesamtpreis').html(gesamtpreisString);
	}
} 

// bos aufbauen
function initGesamtpreis() {
	window.setTimeout(function() {
		var livecalc = parseInt($('#add-to-cart #quantity-grp').data('livecalc'));

		if (livecalc === 1) {
			var boxGesamtpreis = $(document).find('#preisberechnung'),
				offset = ($(document).find('#add-to-cart').outerWidth() - $(document).find('#add-to-cart #quantity-grp').outerWidth()) / 2,
				minusButton = $(document).find('#add-to-cart #quantity-grp .btn-minus').parent().outerWidth(),
				pfeil = 0,
				preis = 0,
				gesamtpreis = 0,
				symbolTimes = 0,
				symbolGleich = 0;

			//console.log(boxGesamtpreis);
			pfeil = $(document).find('#add-to-cart #quantity-grp #quantity').outerWidth() + offset + minusButton - 15;
			symbolTimes = $(document).find('#preisberechnung .symbol-times').outerWidth();
			//preis = $('#preisberechnung .preis').outerWidth();
			preisDimenstions = $(document).find("#preisberechnung .preis").getRealDimensions;
			preis = preisDimenstions.width;
			symbolGleich = $(document).find('#preisberechnung .symbol-gleich').outerWidth();

			console.log($(document).find('#add-to-cart').outerWidth() + ' - ' + minusButton + ' - ' + pfeil + ' - ' + Math.abs(symbolTimes) + ' - ' +  preis + ' - ' +  Math.abs(symbolGleich));
			gesamtpreis = $(document).find('#add-to-cart').outerWidth() - minusButton - pfeil - Math.abs(symbolTimes) - preis - Math.abs(symbolGleich) - (offset) - 15;

			$(document).find('#preisberechnung .pfeil').outerWidth(pfeil);
			$(document).find('#preisberechnung .preis').outerWidth(preis);
			$(document).find('#preisberechnung .gesamtpreis').outerWidth(gesamtpreis);
			//console.log('test');
			calcGesamtpreis();
			boxGesamtpreis.fadeIn('slow');
			//console.log('test');
		}
	}, 5);
}

//////  bulk price rows
var bulks = '.bulk-price table > tbody tr';
$(document).on('click touch', bulks, function() {
	var quantity = parseInt($(this).find('td:first-child').text());
	if (!isNaN(quantity)) {
		$(document).find('input#quantity').val(quantity);
		$(document).find(bulks).removeClass('set');
		$(this).addClass('set');
		calcGesamtpreis();
	}
});

///// Plus Minus Buttons

$(document).on('click touchend', '#add-to-cart #quantity-grp .btn-plus', function(e) {
	e.stopImmediatePropagation();
	console.log('klick plus');
	updateQuatity('plus');
});
$(document).on('click touchend', '#add-to-cart #quantity-grp .btn-minus', function(e) {
	e.stopImmediatePropagation();
	console.log('klick minus');
	updateQuatity('minus');
});

function updateQuatity(plusminus) {
	var min = parseInt($('#quantity').data('min'));
	var int = parseInt($('#quantity').data('int'));
	var quantity = parseInt($('#quantity').val());
	var newquantity = quantity;
	var addition = 1;
	
	if (!isNaN(min) && int > 1) {
		addition = int;
	}
	
	if (min == 0 || isNaN(min)) {
		min = 1;
	}
	
	if (plusminus == 'minus') {
		addition = addition*-1;
		console.log('neagive Addition');
	}
	
	newquantity = newquantity + (addition);

	if (newquantity < min) {
		newquantity = min;
		console.log('Korrektur, QTY darf nicht unter ' + min + ' sein!');
		errorMindestabnahme();
	} else {
		$('#quantity').val(newquantity);
		calcGesamtpreis();
	}
	//console.log('quantity:  ' + quantity + '; min:  ' + min + '; int: ' + int + '; addition: ' + addition + '; newquantity: ' + newquantity);
	
}

/*** Artikelliste ***/


